//----------------------------------------------------------------------//
// Sound Band															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "MidiPort.h"
#include "Band.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

Band BD[MAX_BAND];
field_prm Fprm;

int map_scl[25] = {3,2,0,2,3, 2,1,0,1,2, 0,0,0,0,0, 2,1,0,1,2, 3,2,0,2,3};
int scltb[5][HLF_BAND];

//---------------------------------------------------------------------
//т̐FĐݒ
//---------------------------------------------------------------------
void set_band_color()
{
	BD[0].col = Fprm.col_lower0;
	for (int i=0; i<HLF_BAND; i++) {
		int c0 = Fprm.col_lower0 % 256;
		int c1 = Fprm.col_upper0 % 256;
		BD[i].col = c0+(c1-c0)*i/(HLF_BAND);
		c0 = (Fprm.col_lower0>>8) % 256;
		c1 = (Fprm.col_upper0>>8) % 256;
		BD[i].col += (c0+(c1-c0)*i/(HLF_BAND))<<8;
		c0 = (Fprm.col_lower0>>16) % 256;
		c1 = (Fprm.col_upper0>>16) % 256;
		BD[i].col += (c0+(c1-c0)*i/(HLF_BAND))<<16;
		BD[i].shape->Brush->Color = (TColor)BD[i].col;
		BD[i].shape->Pen->Color   = (TColor)BD[i].col;
	}

	BD[HLF_BAND].col = Fprm.col_lower1;
	for (int j=0; j<HLF_BAND; j++) {
		int i = j+HLF_BAND;
		int c0 = Fprm.col_lower1 % 256;
		int c1 = Fprm.col_upper1 % 256;
		BD[i].col = c0+(c1-c0)*j/(HLF_BAND);
		c0 = (Fprm.col_lower1>>8) % 256;
		c1 = (Fprm.col_upper1>>8) % 256;
		BD[i].col += (c0+(c1-c0)*j/(HLF_BAND))<<8;
		c0 = (Fprm.col_lower1>>16) % 256;
		c1 = (Fprm.col_upper1>>16) % 256;
		BD[i].col += (c0+(c1-c0)*j/(HLF_BAND))<<16;
		BD[i].shape->Brush->Color = (TColor)BD[i].col;
	}
}

//---------------------------------------------------------------------
void put_band(int n)
{
	TShape* sp = BD[n].shape;
	int wd = sp->Parent->ClientWidth;
	if (BD[n].threshold>0) {
		sp->Width = BD[n].value*wd/6/BD[n].threshold;
	}
	else
		sp->Width = 0;

	sp->Left = BD[n].xp-(sp->Width/2);
	int dh = BD[n].shape->Height/2;

	if (Fprm.divmode==1) {
		if ((n/(HLF_BAND/2))%2==0)
			sp->Top = BD[n].yp+dh;
		else
			sp->Top = BD[n].yp-dh;
	}
	else {
		sp->Top = BD[n].yp;
	}
}

//---------------------------------------------------------------------
int test_tone(int n)
{
	int ret=-1;
	for (int i=0; i<MAX_TONE; i++) {
		if (MidiPort->tone[i].flag==1) {
			if (MidiPort->tone[i].ownr==n) { ret=i; break; }
		}
	}
    return ret;
}

//---------------------------------------------------------------------
//
//---------------------------------------------------------------------
int fire_tone(int i0,int i1)
{
	int ret = 0;

	double maxv = -99999.0;
	int maxn = -1;
	for (int i=i0; i<=i1; i++) {
		if (BD[i].value>maxv) {
			maxv = BD[i].value;
			maxn = i;
		}
	}
	if (maxn!=-1) {
		if (maxv>BD[maxn].threshold) {
			if (BD[maxn].stat==0) {
				if ((Fprm.power<Fprm.limit)&&(test_tone(maxn)==-1)) {
					int v  = Fprm.power*6+40+BD[maxn].stress; if (v>127) v=127;
					int bn = maxn; if (bn>=HLF_BAND) bn -= HLF_BAND;
					int k  = scltb[map_scl[Fprm.arean]][bn]; k += Fprm.parity_y*8;
					int t  = 4/(Fprm.speed*Fprm.speed);
					BD[maxn].tone_id = MidiPort->cre_ton(BD[maxn].chn,k,v,t,maxn);
					BD[maxn].stat	 = 1;
					BD[maxn].value	/= 2;
					BD[maxn].stress  = 0;
					ret = 1;
				}
			}
		}
	}
	return ret;
}


//---------------------------------------------------------------------
//т̃TCYƈʒuĐݒ
//---------------------------------------------------------------------
void resize_band()
{
	TShape *sp = BD[0].shape;
	int wd	 = sp->Parent->ClientWidth;
	int hi	 = sp->Parent->ClientHeight;
	int hi_b = hi*2/(MAX_BAND+12);

	for (int i=0; i<HLF_BAND; i++) {
		int j = i + HLF_BAND;
		BD[i].shape->Height = hi_b;
		BD[j].shape->Height = hi_b;
		BD[i].xp = wd/4;
		BD[j].xp = wd/4*3;
		BD[i].yp = BD[j].yp = hi_b*((HLF_BAND-i)+2);
	}
}

//---------------------------------------------------------------------
//Ԃ̍XV
//---------------------------------------------------------------------
void upd_band(double vx, double vy)
{
	Fprm.parity_y = vy*2.8;
    Fprm.parity_x = vx*2.8;
	Fprm.arean	  = (Fprm.parity_y+2)*5+Fprm.parity_x+2;
    if (Fprm.arean<0) Fprm.arean=0; else if (Fprm.arean>24) Fprm.arean=24;

	double s = sqrt(vx*vx+vy*vy);
	Fprm.limit = 10+s*20;
	Fprm.speed = 1.0-fabs(s)*0.50;

	Fprm.power0 = Fprm.power1 = 0;
	for (int i=0; i<MAX_BAND; i++) {
		int n = test_tone(i);
		if (n!=-1) {
			if (i<HLF_BAND) {
				Fprm.power0 += MidiPort->tone[n].vel;
			}
			else {
				Fprm.power1 += MidiPort->tone[n].vel;
			}
		}
		else {
			BD[i].stat = 0;
		}
	}
	Fprm.power=(Fprm.power0+Fprm.power1)/MAX_BAND;

	Fprm.vsum0=0.0; Fprm.vsum1=0.0; Fprm.stress=0;
	for (int i=0; i<HLF_BAND; i++) {
		int j = i+HLF_BAND;
		Fprm.vsum0	+= BD[i].value;
		Fprm.vsum1	+= BD[j].value;
		Fprm.stress += BD[i].stress;
		Fprm.stress += BD[j].stress;
	}

	for (int i=0; i<HLF_BAND; i++) {
		int j = i+HLF_BAND;
		double di = 1.0;
		if ((Fprm.parity_x<=0)||(abs(Fprm.parity_x)==1)) {
			if (BD[i].stat==1) {
				di -= BD[i].value/2;
			}
			else {
				di += (BD[i].threshold*2-BD[i].value)/20;
				if (BD[i].value>4.0) {
					di -= BD[j].stat*3;
					if (i>0) di -= BD[j-1].stat;
					if (i<HLF_BAND-1) di -= BD[j+1].stat;
				}
			}
		}

		double dj = 1.0;
		if ((Fprm.parity_x>=0)||(abs(Fprm.parity_x)==1)) {
			if (BD[j].stat==1) {
				dj -= BD[j].value/2;
			}
			else {
				dj += (BD[j].threshold*2-BD[j].value)/25;
				if (BD[j].value>4.0) {
					dj -= BD[i].stat*3;
					if (i>0) dj -= BD[i-1].stat;
					if (i<HLF_BAND-1) dj -= BD[i+1].stat;
				}
			}
		}

		int n;
		if ((Fprm.parity_x<=0)||(abs(Fprm.parity_x)==1)) {
			if (Fprm.parity_x<0) {
				n = i-1; if (n<0) n = HLF_BAND-1;
			}
			else {
				n = i+1; if (n==HLF_BAND) n = 0;
			}
			BD[i].value += (BD[n].value-BD[i].value)*Fprm.speed*0.20;
		}
		if ((Fprm.parity_x>=0)||(abs(Fprm.parity_x)==1)) {
			if (Fprm.parity_x>0) {
				n = j-1; if (n<HLF_BAND)  n = MAX_BAND-1;
			}
			else {
				n = j+1; if (n==MAX_BAND) n = HLF_BAND;
			}
			BD[j].value += (BD[n].value-BD[j].value)*Fprm.speed*0.25;
		}
		BD[i].value += di*Fprm.speed;
		BD[j].value += dj*Fprm.speed;
	}

	if (Fprm.lopcnt%2==0) {
		fire_tone(0,HLF_BAND-1);
		fire_tone(HLF_BAND,MAX_BAND-1);
		if (Fprm.stress>127) {
			fire_tone(0,HLF_BAND-1);
			fire_tone(HLF_BAND,MAX_BAND-1);
		}
	}

	for (int i=0; i<MAX_BAND; i++) {
		BD[i].stress = 0;
		if (BD[i].value>BD[i].threshold) {
			if (BD[i].stat==0) BD[i].stress = (BD[i].value-BD[i].threshold);
			BD[i].shape->Pen->Color = (TColor)(Fprm.col_active);
		}
		else {
			BD[i].shape->Pen->Color = (TColor)BD[i].col;
		}
	}
	for (int i=0; i<MAX_BAND; i++) put_band(i);
}
//---------------------------------------------------------------------

