//----------------------------------------------------------------------//
// Sound Band	CtH[											//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <Vcl.HtmlHelpViewer.hpp>
#include "usr_wic.h"
#include "Sensor.h"
#include "Band.h"
#include "SndDlg.h"
#include "DsgnDlg.h"
#include "About.h"
#include "MainForm.h"

#pragma link "Vcl.HTMLHelpViewer"

extern int map_scl[25];
extern int scltb[5][HLF_BAND];

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TSbandMainForm *SbandMainForm;

Sensor SS[2];

//---------------------------------------------------------------------------
__fastcall TSbandMainForm::TSbandMainForm(TComponent* Owner)
    : TForm(Owner)
{
	Alive = false;
}

//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormCreate(TObject *Sender)
{
	DoubleBuffered = true;	//h~

	//wv̏
	Application->HelpFile = ChangeFileExt(Application->ExeName, ".CHM");

	//INIt@Cǂݍ
	IniFile = new TIniFile(ExtractFilePath(Application->ExeName)+"SBAND.INI");
	UnicodeString sct = "Color";
	Fprm.col_backgr = (TColor)IniFile->ReadInteger(sct,"Background",clBlack);
	Fprm.col_active = (TColor)IniFile->ReadInteger(sct,"Active",	clRed);
	Fprm.col_lower0 = (TColor)IniFile->ReadInteger(sct,"Lower0",	clNavy);
	Fprm.col_upper0 = (TColor)IniFile->ReadInteger(sct,"Upper0",	clPurple);
	Fprm.col_lower1 = (TColor)IniFile->ReadInteger(sct,"Lower1",	clNavy);
	Fprm.col_upper1 = (TColor)IniFile->ReadInteger(sct,"Upper1",	clLime);
	Color = (TColor)(Fprm.col_backgr);

	//wi[h
	sct = "Design";
	Fprm.bgimg		   = new Graphics::TBitmap();
	Fprm.enable_bgimg  = IniFile->ReadBool(sct,"EnableBgImage",		false);
	Fprm.stretch_bgimg = IniFile->ReadBool(sct,"StretchBgImage",	false);
	Fprm.bgimg_file    = IniFile->ReadString(sct,"BgImage", EmptyStr);
	if (FileExists(Fprm.bgimg_file))
		WIC_load_image(Fprm.bgimg_file, Fprm.bgimg);
	else
		Fprm.bgimg_file = EmptyStr;

	Fprm.hide_titlebar = IniFile->ReadBool(sct,"HideTitlebar",	false);

	//Sensor 
  	//͂Ƀ}EXʒu蓖
    SS[0].lpSource = &mouseX;
    SS[1].lpSource = &mouseY;
	//tB^[̐ݒ (Tv4ŕω)
	SS[0].ini_filter(0, 4);
	SS[1].ini_filter(0, 4);

	// MIDȈ
	sct = "Sound";
	MidiPort = new TMidiPort();
	MidiPort->DevNum = IniFile->ReadInteger(sct,"Driver",0);
	MidiPort->OutOpen();
	Fprm.volume = IniFile->ReadInteger(sct,"Volume",90);
	Fprm.stereo = IniFile->ReadInteger(sct,"Stereo",0);
	//Fݒ
	for (int i=0; i<MAX_MIDICHN; i++) {
		int pn = IniFile->ReadInteger(sct, UnicodeString().sprintf(_T("Prg_%02X"), i), 1);
		MidiPort->SetPrg(i, pn-1);
	}
	//ʂƃp̐ݒ
	MidiPort->SetVolume(0,Fprm.volume);
	MidiPort->SetVolume(1,Fprm.volume);
	if (Fprm.stereo==1) {
		//XeI
		MidiPort->SetPan(0,32);
		MidiPort->SetPan(1,96);
	}
	else {
		MidiPort->SetPan(0,64);
		MidiPort->SetPan(1,64);
	}

	// т̏
	TShape *sp;
	for (int i=0; i<MAX_BAND; i++) {
		sp			= new TShape(this);
		sp->Parent	= this;
		sp->Shape	= stRectangle;
		sp->Tag 	= i;
		BD[i].shape = sp;
	}
	set_band_color();

	for (int i=0; i<HLF_BAND; i++) {
		int j = i+HLF_BAND;
		BD[i].threshold = BD[j].threshold = 127;
		BD[i].value 	= BD[j].value	  = i*8.0;
		BD[i].stress	= BD[j].stress	  = 0;
		BD[i].stat		= BD[j].stat	  = 0;
		BD[i].chn		= 0;
		BD[j].chn		= 1;
	}

	for (int i=0; i<HLF_BAND; i++) {
		scltb[0][i] = 40+i*4-(i % 3)/2;
		scltb[1][i] = 40+i*4+(i % 3)/2;
		scltb[2][i] = 40+i*4;
		scltb[3][i] = 32+i*5;
	}

    Fprm.lopcnt 	= 0;
	Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormShow(TObject *Sender)
{
	UnicodeString sct = "General";
	WindowState 	= (TWindowState)IniFile->ReadInteger(sct,"WinState",wsNormal);
	Width			= IniFile->ReadInteger(sct,"WinWidth",	640);
	Height			= IniFile->ReadInteger(sct,"WinHeight",	480);
	Left			= IniFile->ReadInteger(sct,"WinLeft",	(Screen->Width-Width)/2);
	Top 			= IniFile->ReadInteger(sct,"WinTop", 	(Screen->Height-Height)/2);
	SoundDlg->Left	= IniFile->ReadInteger(sct,"SoundDlgLeft",	Left+50);
	SoundDlg->Top	= IniFile->ReadInteger(sct,"SoundDlgTop", 	Top+50);
	DesignDlg->Left = IniFile->ReadInteger(sct,"DesignDlgLeft",	Left+100);
	DesignDlg->Top	= IniFile->ReadInteger(sct,"DesignDlgTop", 	Top+100);

    //ZT[̃WʃTCYɐݒ
	SS[0].SetRange(0,ClientWidth);
	SS[1].SetRange(0,ClientHeight);

	//т`
	resize_band();
	for (int i=0; i<MAX_BAND; i++) put_band(i);

	//}EX
	POINT mp;
	mp.x   = ClientWidth/2;
	mp.y   = ClientHeight/2;
	mouseX = mp.x;
	mouseY = mp.y;
	MapWindowPoints(Handle,NULL,&mp,1);
	SetCursorPos(mp.x,mp.y);

	Alive = true;
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Timer1->Enabled = false;
	Alive			= false;

	//ݒ̕ۑ
	UnicodeString sct = "General";
	IniFile->WriteInteger(sct,"WinState", 	WindowState);
	IniFile->WriteInteger(sct,"WinTop",   	Top);
	IniFile->WriteInteger(sct,"WinLeft",  	Left);
	IniFile->WriteInteger(sct,"WinWidth", 	Width);
	IniFile->WriteInteger(sct,"WinHeight",	Height);
   	IniFile->WriteInteger(sct,"SoundDlgLeft",	SoundDlg->Left);
   	IniFile->WriteInteger(sct,"SoundDlgTop",	SoundDlg->Top);
	IniFile->WriteInteger(sct,"DesignDlgLeft",	DesignDlg->Left);
    IniFile->WriteInteger(sct,"DesignDlgTop",	DesignDlg->Top);

	sct = "Color";
	IniFile->WriteInteger(sct,"Background",Fprm.col_backgr);
	IniFile->WriteInteger(sct,"Upper0",    Fprm.col_upper0);
	IniFile->WriteInteger(sct,"Lower0",    Fprm.col_lower0);
	IniFile->WriteInteger(sct,"Upper1",    Fprm.col_upper1);
	IniFile->WriteInteger(sct,"Lower1",    Fprm.col_lower1);
	IniFile->WriteInteger(sct,"Active",    Fprm.col_active);

	sct = "Design";
    IniFile->WriteString(sct, "BgImage",		Fprm.bgimg_file);
	IniFile->WriteBool(sct,"EnableBgImage",		Fprm.enable_bgimg);
	IniFile->WriteBool(sct,"StretchBgImage",	Fprm.stretch_bgimg);
	IniFile->WriteBool(sct,"HideTitlebar",		Fprm.hide_titlebar);

	sct = "Sound";
	IniFile->WriteInteger(sct,"driver", MidiPort->DevNum);
	IniFile->WriteInteger(sct,"Volume", Fprm.volume);
	IniFile->WriteInteger(sct,"Stereo", Fprm.stereo);
	for (int i=0; i<MAX_MIDICHN; i++) {
		IniFile->WriteString(
			sct, UnicodeString().sprintf(_T("Prg_%02X"), i), MidiPort->ChnPrg[i]+1);
	}

	//MIDIfoCX
	MidiPort->OutClose();
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormDestroy(TObject *Sender)
{
	delete MidiPort;
	delete IniFile;
    delete Fprm.bgimg;
}

//---------------------------------------------------------------------------
// ʔwi̕`
void __fastcall TSbandMainForm::FormPaint(TObject *Sender)
{
	if (Fprm.enable_bgimg) {
		try {
			if (!Fprm.bgimg->Empty) {
				//O`ɍ킹
				if (Fprm.stretch_bgimg) {
					Canvas->StretchDraw(ClientRect, Fprm.bgimg);
				}
				//ׂĕ~l߂
				else {
					for(int x=0; x<ClientWidth; x+=Fprm.bgimg->Width) {
						for(int y=0; y<ClientHeight; y+=Fprm.bgimg->Height) {
							Canvas->Draw(x,y, Fprm.bgimg);
						}
					}
				}
			}
		}
		catch(...) {
			Fprm.enable_bgimg = false;
		}
	}
}
//---------------------------------------------------------------------
// ő剻␳(^Cgo[ƃj[B)
void __fastcall TSbandMainForm::WmGetMinMaxInfo(TWMGetMinMaxInfo &Msg ){
	TForm::Dispatch(&Msg);
	if (Fprm.hide_titlebar) {
		RECT rc;
		::GetWindowRect(GetDesktopWindow(),&rc);
		::AdjustWindowRect(&rc, WS_OVERLAPPEDWINDOW, TRUE);
		Msg.MinMaxInfo->ptMaxSize.y		 = rc.bottom-rc.top;
		Msg.MinMaxInfo->ptMaxTrackSize.y = rc.bottom-rc.top;
		Msg.MinMaxInfo->ptMaxPosition.y	 = rc.top;
	}
}

//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	mouseX = X;
	mouseY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormResize(TObject *Sender)
{
	if (Alive) {
	    //ZT[̃WʃTCYɐݒ
	   	SS[0].SetRange(0,ClientWidth);
		SS[1].SetRange(0,ClientHeight);
		resize_band();
	}
}

//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FormClick(TObject *Sender)
{
    if (Fprm.divmode==0) Fprm.divmode=1; else Fprm.divmode=0;
}

//---------------------------------------------------------------------------
// Timer 
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::Timer1Timer(TObject *Sender)
{
	Fprm.lopcnt++;

	//ZT[̍XV
	SS[0].update();
	SS[1].update();

	//тXV
	double vx = SS[0].get_valueSF(0);
	double vy = -SS[1].get_valueSF(0);
	upd_band(vx,vy);

	MidiPort->upd_ton();
}

//---------------------------------------------------------------------------
// j[
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::FileExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::OptSoundItemClick(TObject *Sender)
{
	SoundDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::OptDesignClick(TObject *Sender)
{
    DesignDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::HelpContentsClick(TObject *Sender)
{
	Application->HelpShowTableOfContents();
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::HelpAboutClick(TObject *Sender)
{
 	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::PopRestoreItemClick(TObject *Sender)
{
	WindowState = wsNormal;
}
//---------------------------------------------------------------------------
void __fastcall TSbandMainForm::PopupMenu1Popup(TObject *Sender)
{
	PopRestoreItem->Visible = (Fprm.hide_titlebar && (WindowState==wsMaximized));
}
//---------------------------------------------------------------------------

